local Decliner = CreateFrame('frame', DECLINERNAME)

local _, action, addon, answer, frame, guild, justify, lasttell, message, name, namerealm,
oldSFX, panel, pattern, sh, text, tooltip, tradeinitiated, value, x, xloc, yloc

function Decliner:Patterns(pattern)
	pattern = string.gsub(pattern, '|Hplayer:', '')
	pattern = string.gsub(pattern, '%%%d?$?c', '')
	pattern = string.gsub(pattern, '%%%d?$?d', '')
	pattern = string.gsub(pattern, '%%%d?$?s', '')
	pattern = string.gsub(pattern, '%[.*%]', '')
	pattern = string.gsub(pattern, ':.*', '')
	pattern = string.gsub(pattern, '|h', '')
	pattern = string.gsub(pattern, '%.', '')
	pattern = string.gsub(pattern, '^%s', '')
	pattern = string.gsub(pattern, '%s$', '')
	return pattern
end -- credit to Phanx (SpamAway, but initially a pattern matching thread on WoWInterface)

local tradeinisysmsg = '.*'..Decliner:Patterns(ERR_INITIATE_TRADE_S)..'.*'
local duelsysmsg = '.*'..Decliner:Patterns(DUEL_REQUESTED)..'.*'
local petduelsysmsg = '.*'..Decliner:Patterns(PET_BATTLE_PVP_DUEL_REQUESTED)..'.*'
local guildsysmsg = '.*'..Decliner:Patterns(ERR_INVITED_TO_GUILD_SSS)..'.*'
local groupsysmsg = '.*'..Decliner:Patterns(ERR_INVITED_TO_GROUP_SS)..'.*'
--local chartsysmsg = '.*'..Decliner:Patterns(PETITION?)..'.*'
--local tradesysmsg = '.*'..Decliner:Patterns(ERR_TRADE_REQUEST_S)..'.*'

--	enUS global strings shown below for reference
--	ERR_INITIATE_TRADE_S = "You have requested to trade with %s."
--	DUEL_REQUESTED = "%s has challenged you to a duel."
--	PET_BATTLE_PVP_DUEL_REQUESTED = "%s has challenged you to a pet-battle."
--	ERR_INVITED_TO_GUILD_SSS = "|Hplayer:%s|h[%s]|h invites you to join %s."
--	ERR_INVITED_TO_GROUP_SS = "|Hplayer:%s|h[%s]|h has invited you to join a group."
--	ERR_TRADE_REQUEST_S = "%s has requested to trade with you."

function Decliner:localName(namerealm)
	local toon, realm = namerealm:match('^(.*)%s*-%s*([^-]*)$')
	local myrealm = GetRealmName()
	local myrealm = myrealm:gsub('%s', '')
	if realm == myrealm then
		return toon
	else
		return toon..'-'..realm
	end
end

function Decliner:fullName(name)
	local toon, realm = name:match('^(.*)%s*-%s*([^-]*)$')
	if not realm or #realm == 0 then
		toon = name
		realm = GetRealmName()
	end
	realm = realm:gsub('%s', '')
	return toon..'-'..realm
end -- credit to RaidBuffStatus

function Decliner:isNotGuildie(name)
	local answer = true
	if (IsInGuild()) then
		for i=1, GetNumGuildMembers() do
			local gname = GetGuildRosterInfo(i)
			if name == Decliner:fullName(gname) then
				answer = false
				return answer
			end
		end
	end
	return answer
end -- credit to Broker_AntiSocial

function Decliner:isNotFriend(name)
	local answer = true
	for i=1, GetNumFriends() do
		local fname = GetFriendInfo(i)
		if name == Decliner:fullName(fname) then
			answer = false
			return answer
		end
	end
	return answer
end -- credit to Broker_AntiSocial

function Decliner:isNotBNFriend(name)
	local answer = true
	for i=1, BNGetNumFriends() do
		local _, _, _, _, _, _, client, isOnline = BNGetFriendInfo(i)
		if client == 'WoW' and isOnline then
			for j=1, BNGetNumFriendToons(i) do
				local _, toonName, _, realmName = BNGetFriendToonInfo(i, j)
				if name == toonName..'-'..realmName:gsub('%s', '') then
					answer = false
					return answer
				end
			end
		end
	end
	return answer
end -- credit to RaidBuffStatus

function Decliner:Print(message)
	local channel = 'CHAT_MSG_SYSTEM'
 	for i=1, NUM_CHAT_WINDOWS do
		local chatframe = _G['ChatFrame'..i]
		if chatframe:IsEventRegistered(channel) and not declinervars.opt.dcl.messages then
			chatframe:AddMessage("|cffff0000"..DECLINERNAME..": |cffffff00"..message.."")
		end
	end
end -- credit to Jaliborc (Scrap), but used AddMessage instead of the oft-hooked MessageHandler

function Decliner:CleanVars()
	declinervars.opt = nil
	declinervars.opt = {
		duel = { enabled, tell, guild, friend, bnet, message, },
		pet = { enabled, tell, guild, friend, bnet, message, },
		guild = { enabled, tell, friend, bnet, message, },
		group = { enabled, tell, guild, friend, bnet, message, },
		chart = { enabled, tell, guild, friend, bnet, message, },
		trade = { enabled, tell, guild, friend, bnet, message, },
		dcl = { messages, disable, },
	}
end

ChatFrame_AddMessageEventFilter('CHAT_MSG_SYSTEM', function(_, _, message)
	if not declinervars.opt.dcl.disable then
		if string.match(message, duelsysmsg) and
		declinervars.opt.duel.enabled and
		((lasttell ~= namerealm) or declinervars.opt.duel.tell) and
		(Decliner:isNotGuildie(namerealm) or declinervars.opt.duel.guild) and
		(Decliner:isNotFriend(namerealm) or declinervars.opt.duel.friend) and
		(Decliner:isNotBNFriend(namerealm) or declinervars.opt.duel.bnet) then
			return true
		elseif string.match(message, petduelsysmsg) and
		declinervars.opt.pet.enabled and
		((lasttell ~= namerealm) or declinervars.opt.pet.tell) and
		(Decliner:isNotGuildie(namerealm) or declinervars.opt.pet.guild) and
		(Decliner:isNotFriend(namerealm) or declinervars.opt.pet.friend) and
		(Decliner:isNotBNFriend(namerealm) or declinervars.opt.pet.bnet) then
			return true
		elseif string.match(message, guildsysmsg) and
		declinervars.opt.guild.enabled and
		((lasttell ~= namerealm) or declinervars.opt.guild.tell) and
		(Decliner:isNotFriend(namerealm) or declinervars.opt.guild.friend) and
		(Decliner:isNotBNFriend(namerealm) or declinervars.opt.guild.bnet) then
			return true
		elseif string.match(message, groupsysmsg) and
		declinervars.opt.group.enabled and
		((lasttell ~= namerealm) or declinervars.opt.group.tell) and
		(Decliner:isNotGuildie(namerealm) or declinervars.opt.group.guild) and
		(Decliner:isNotFriend(namerealm) or declinervars.opt.group.friend) and
		(Decliner:isNotBNFriend(namerealm) or declinervars.opt.group.bnet) then
			return true
--		elseif string.match(message, chartsysmsg) and
--		declinervars.opt.chart.enabled and
--		((lasttell ~= namerealm) or declinervars.opt.chart.tell) and
--		(Decliner:isNotGuildie(namerealm) or declinervars.opt.chart.guild) and
--		(Decliner:isNotFriend(namerealm) or declinervars.opt.chart.friend) and
--		(Decliner:isNotBNFriend(namerealm) or declinervars.opt.chart.bnet) then
--			return true -- there's no system message for petitions
--		elseif string.match(message, tradesysmsg) and
--		declinervars.opt.trade.enabled and
--		((lasttell ~= namerealm) or declinervars.opt.trade.tell) and
--		(Decliner:isNotGuildie(namerealm) or declinervars.opt.trade.guild) and
--		(Decliner:isNotFriend(namerealm) or declinervars.opt.trade.friend) and
--		(Decliner:isNotBNFriend(namerealm) or declinervars.opt.trade.bnet) then
--			return true -- this was used when trades were confirmed with a popup, now the trade window just appears
		else return false
		end
	else return false
	end
end)

local textnumber = 0
function Decliner:CreateText(xloc, yloc, justify, text)
	textnumber = textnumber + 1
	local textname = DECLINERNAME..'TextGlobalName'..string.format('%02i', textnumber)
	local settext = DeclinerPanel:CreateFontString(textname, 'ARTWORK', 'GameFontNormalSmall')
	settext:SetPoint(justify, DeclinerPanel, 'TOPLEFT', xloc, yloc)
	settext:SetText(text)
	return settext
end

local checkboxnumber = 0
function Decliner:CreateCheckButton(xloc, yloc, tooltip, label)
	checkboxnumber = checkboxnumber + 1
	local checkboxname = DECLINERNAME..'CheckBoxGlobalName'..string.format('%02i', checkboxnumber)
	local checkbox = CreateFrame('CheckButton', checkboxname, DeclinerPanel, 'InterfaceOptionsCheckButtonTemplate')
	checkbox:SetPoint('CENTER', DeclinerPanel, 'TOPLEFT', xloc, yloc)
	checkbox:SetHitRectInsets(0, 0, 0, 0)
	checkbox.tooltipText = tooltip
	_G[checkboxname..'Text']:SetText('|cffff0000'..label)
	return checkbox
end -- credit to http://wow.gamepedia.com/UIOBJECT_CheckButton#Recommendation for this neat 'checkbutton factory' function that I also used to make CreateText above

function Decliner:Options()
	local DeclinerPanel = CreateFrame('frame', DECLINERNAME..'Panel')
	DeclinerPanel.name = DECLINERNAME
	InterfaceOptions_AddCategory(DeclinerPanel, DECLINERNAME)
	DeclinerText01 = Decliner:CreateText(144, -32, 'CENTER', DUEL, '')
	DeclinerText02 = Decliner:CreateText(144, -48, 'CENTER', GUILDINFOTAB_APPLICANTS_NONE, '')
	DeclinerText03 = Decliner:CreateText(208, -32, 'CENTER', PET_BATTLE_PVP_DUEL, '')
	DeclinerText04 = Decliner:CreateText(208, -48, 'CENTER', GUILDINFOTAB_APPLICANTS_NONE, '')
	DeclinerText05 = Decliner:CreateText(272, -32, 'CENTER', GUILD, '')
	DeclinerText06 = Decliner:CreateText(272, -48, 'CENTER', Decliner:Patterns(GUILDEVENT_TYPE_INVITE), '')
	DeclinerText07 = Decliner:CreateText(336, -32, 'CENTER', GROUP, '')
	DeclinerText08 = Decliner:CreateText(336, -48, 'CENTER', Decliner:Patterns(GUILDEVENT_TYPE_INVITE), '')
	DeclinerText09 = Decliner:CreateText(400, -32, 'CENTER', ARENA.."/"..GUILD, '')
	DeclinerText10 = Decliner:CreateText(400, -48, 'CENTER', Decliner:Patterns(PETITION_TITLE), '')
	DeclinerText11 = Decliner:CreateText(464, -32, 'CENTER', TRADE, '')
	DeclinerText12 = Decliner:CreateText(464, -48, 'CENTER', GUILDINFOTAB_APPLICANTS_NONE, '')
	DeclinerText13 = Decliner:CreateText(8, -80, 'LEFT', ENABLE.." "..DECLINE, '')
	DeclinerCheckBox01 = Decliner:CreateCheckButton(144, -80, DeclinerL['DUEL_ENABLE'], '')
	DeclinerCheckBox02 = Decliner:CreateCheckButton(208, -80, DeclinerL['PET_ENABLE'], '')
	DeclinerCheckBox03 = Decliner:CreateCheckButton(272, -80, DeclinerL['GUILD_ENABLE'], '')
	DeclinerCheckBox04 = Decliner:CreateCheckButton(336, -80, DeclinerL['GROUP_ENABLE'], '')
	DeclinerCheckBox05 = Decliner:CreateCheckButton(400, -80, DeclinerL['CHART_ENABLE'], '')
	DeclinerCheckBox06 = Decliner:CreateCheckButton(464, -80, DeclinerL['TRADE_ENABLE'], '')
	DeclinerText14 = Decliner:CreateText(8, -144, 'LEFT', DeclinerL['TELL_TITLE'], '')
	DeclinerCheckBox07 = Decliner:CreateCheckButton(144, -144, DeclinerL['DUEL_TELL'], '')
	DeclinerCheckBox08 = Decliner:CreateCheckButton(208, -144, DeclinerL['PET_TELL'], '')
	DeclinerCheckBox09 = Decliner:CreateCheckButton(272, -144, DeclinerL['GUILD_TELL'], '')
	DeclinerCheckBox10 = Decliner:CreateCheckButton(336, -144, DeclinerL['GROUP_TELL'], '')
	DeclinerCheckBox11 = Decliner:CreateCheckButton(400, -144, DeclinerL['CHART_TELL'], '')
	DeclinerCheckBox12 = Decliner:CreateCheckButton(464, -144, DeclinerL['TRADE_TELL'], '')
	DeclinerText15 = Decliner:CreateText(8, -208, 'LEFT', Decliner:Patterns(INSPECT_GUILD_NUM_MEMBERS), '')
	DeclinerCheckBox13 = Decliner:CreateCheckButton(144, -208, DeclinerL['DUEL_GUILD'], '')
	DeclinerCheckBox14 = Decliner:CreateCheckButton(208, -208, DeclinerL['PET_GUILD'], '')
	DeclinerCheckBox15 = Decliner:CreateCheckButton(272, -208, DeclinerL['GUILD_GUILD'], '')
	DeclinerCheckBox16 = Decliner:CreateCheckButton(336, -208, DeclinerL['GROUP_GUILD'], '')
	DeclinerCheckBox17 = Decliner:CreateCheckButton(400, -208, DeclinerL['CHART_GUILD'], '')
	DeclinerCheckBox18 = Decliner:CreateCheckButton(464, -208, DeclinerL['TRADE_GUILD'], '')
	DeclinerText16 = Decliner:CreateText(8, -272, 'LEFT', Decliner:Patterns(FRIENDS_LIST_REALM).." "..FRIENDS, '')
	DeclinerCheckBox19 = Decliner:CreateCheckButton(144, -272, DeclinerL['DUEL_FRIEND'], '')
	DeclinerCheckBox20 = Decliner:CreateCheckButton(208, -272, DeclinerL['PET_FRIEND'], '')
	DeclinerCheckBox21 = Decliner:CreateCheckButton(272, -272, DeclinerL['GUILD_FRIEND'], '')
	DeclinerCheckBox22 = Decliner:CreateCheckButton(336, -272, DeclinerL['GROUP_FRIEND'], '')
	DeclinerCheckBox23 = Decliner:CreateCheckButton(400, -272, DeclinerL['CHART_FRIEND'], '')
	DeclinerCheckBox24 = Decliner:CreateCheckButton(464, -272, DeclinerL['TRADE_FRIEND'], '')
	DeclinerText17 = Decliner:CreateText(8, -336, 'LEFT', REAL_ID.."/"..BATTLETAG, '')
	DeclinerCheckBox25 = Decliner:CreateCheckButton(144, -336, DeclinerL['DUEL_BNET'], '')
	DeclinerCheckBox26 = Decliner:CreateCheckButton(208, -336, DeclinerL['PET_BNET'], '')
	DeclinerCheckBox27 = Decliner:CreateCheckButton(272, -336, DeclinerL['GUILD_BNET'], '')
	DeclinerCheckBox28 = Decliner:CreateCheckButton(336, -336, DeclinerL['GROUP_BNET'], '')
	DeclinerCheckBox29 = Decliner:CreateCheckButton(400, -336, DeclinerL['CHART_BNET'], '')
	DeclinerCheckBox30 = Decliner:CreateCheckButton(464, -336, DeclinerL['TRADE_BNET'], '')
	DeclinerText18 = Decliner:CreateText(8, -400, 'LEFT', SYSTEM_MESSAGES, '')
	DeclinerCheckBox31 = Decliner:CreateCheckButton(144, -400, HIDE.." \""..DECLINERNAME..":"..DUEL.."\" "..SYSTEM_MESSAGES, '')
	DeclinerCheckBox32 = Decliner:CreateCheckButton(208, -400, HIDE.." \""..DECLINERNAME..":"..PET_BATTLE_PVP_DUEL.."\" "..SYSTEM_MESSAGES, '')
	DeclinerCheckBox33 = Decliner:CreateCheckButton(272, -400, HIDE.." \""..DECLINERNAME..":"..GUILD.."\" "..SYSTEM_MESSAGES, '')
	DeclinerCheckBox34 = Decliner:CreateCheckButton(336, -400, HIDE.." \""..DECLINERNAME..":"..GROUP.."\" "..SYSTEM_MESSAGES, '')
	DeclinerCheckBox35 = Decliner:CreateCheckButton(400, -400, HIDE.." \""..DECLINERNAME..":"..Decliner:Patterns(PETITION_TITLE).."\" "..SYSTEM_MESSAGES, '')
	DeclinerCheckBox36 = Decliner:CreateCheckButton(464, -400, HIDE.." \""..DECLINERNAME..":"..TRADE.."\" "..SYSTEM_MESSAGES, '')
	DeclinerCheckBox37 = Decliner:CreateCheckButton(144, -464, DeclinerL['DISABLE_MESSAGES'], DISABLE.." "..string.upper(ALL).." "..DECLINERNAME.." "..SYSTEM_MESSAGES)
	DeclinerCheckBox38 = Decliner:CreateCheckButton(144, -496, DeclinerL['MAIN_DISABLE'], DISABLE.." "..DECLINERNAME)
	DeclinerCheckBox15:SetScript('PostClick',function()
		if sh then StopSound(sh) end
		x=math.random(1,50000)
		_,sh=PlaySoundKitID(x)
	end)
	DeclinerPanel.refresh = function(self)
		Decliner:SetCheckBoxStates()
		Decliner:MainEventReg()
	end
	DeclinerPanel.okay = function(self)
		Decliner:CleanVars()
		Decliner:GetCheckBoxStates()
		declinersavedvars = declinervars.opt
		declinersavedvars.saved = true
	end
	DeclinerPanel.cancel = function(self)
		-- do nothing
	end
	DeclinerPanel.default = function(self)
		Decliner:CleanVars()
		declinervars.opt = declinervars.default
		declinersavedvars = declinervars.default
		declinersavedvars.saved = true
		Decliner:SetCheckBoxStates()
		Decliner:GetCheckBoxStates()
	end
end

function Decliner:SetCheckBoxStates()
	DeclinerCheckBox01:SetChecked(declinervars.opt.duel.enabled)
	DeclinerCheckBox02:SetChecked(declinervars.opt.pet.enabled)
	DeclinerCheckBox03:SetChecked(declinervars.opt.guild.enabled)
	DeclinerCheckBox04:SetChecked(declinervars.opt.group.enabled)
	DeclinerCheckBox05:SetChecked(declinervars.opt.chart.enabled)
	DeclinerCheckBox06:SetChecked(declinervars.opt.trade.enabled)
	DeclinerCheckBox07:SetChecked(declinervars.opt.duel.tell)
	DeclinerCheckBox08:SetChecked(declinervars.opt.pet.tell)
	DeclinerCheckBox09:SetChecked(declinervars.opt.guild.tell)
	DeclinerCheckBox10:SetChecked(declinervars.opt.group.tell)
	DeclinerCheckBox11:SetChecked(declinervars.opt.chart.tell)
	DeclinerCheckBox12:SetChecked(declinervars.opt.trade.tell)
	DeclinerCheckBox13:SetChecked(declinervars.opt.duel.guild)
	DeclinerCheckBox14:SetChecked(declinervars.opt.pet.guild)
	DeclinerCheckBox15:SetChecked(false)
	DeclinerCheckBox16:SetChecked(declinervars.opt.group.guild)
	DeclinerCheckBox17:SetChecked(declinervars.opt.chart.guild)
	DeclinerCheckBox18:SetChecked(declinervars.opt.trade.guild)
	DeclinerCheckBox19:SetChecked(declinervars.opt.duel.friend)
	DeclinerCheckBox20:SetChecked(declinervars.opt.pet.friend)
	DeclinerCheckBox21:SetChecked(declinervars.opt.guild.friend)
	DeclinerCheckBox22:SetChecked(declinervars.opt.group.friend)
	DeclinerCheckBox23:SetChecked(declinervars.opt.chart.friend)
	DeclinerCheckBox24:SetChecked(declinervars.opt.trade.friend)
	DeclinerCheckBox25:SetChecked(declinervars.opt.duel.bnet)
	DeclinerCheckBox26:SetChecked(declinervars.opt.pet.bnet)
	DeclinerCheckBox27:SetChecked(declinervars.opt.guild.bnet)
	DeclinerCheckBox28:SetChecked(declinervars.opt.group.bnet)
	DeclinerCheckBox29:SetChecked(declinervars.opt.chart.bnet)
	DeclinerCheckBox30:SetChecked(declinervars.opt.trade.bnet)
	DeclinerCheckBox31:SetChecked(declinervars.opt.duel.message)
	DeclinerCheckBox32:SetChecked(declinervars.opt.pet.message)
	DeclinerCheckBox33:SetChecked(declinervars.opt.guild.message)
	DeclinerCheckBox34:SetChecked(declinervars.opt.group.message)
	DeclinerCheckBox35:SetChecked(declinervars.opt.chart.message)
	DeclinerCheckBox36:SetChecked(declinervars.opt.trade.message)
	DeclinerCheckBox37:SetChecked(declinervars.opt.dcl.messages)
	DeclinerCheckBox38:SetChecked(declinervars.opt.dcl.disable)
end

function Decliner:GetCheckBoxStates()
	if DeclinerCheckBox01 then declinervars.opt.duel.enabled = DeclinerCheckBox01:GetChecked() end
	if DeclinerCheckBox02 then declinervars.opt.pet.enabled = DeclinerCheckBox02:GetChecked() end
	if DeclinerCheckBox03 then declinervars.opt.guild.enabled = DeclinerCheckBox03:GetChecked() end
	if DeclinerCheckBox04 then declinervars.opt.group.enabled = DeclinerCheckBox04:GetChecked() end
	if DeclinerCheckBox05 then declinervars.opt.chart.enabled = DeclinerCheckBox05:GetChecked() end
	if DeclinerCheckBox06 then declinervars.opt.trade.enabled = DeclinerCheckBox06:GetChecked() end
	if DeclinerCheckBox07 then declinervars.opt.duel.tell = DeclinerCheckBox07:GetChecked() end
	if DeclinerCheckBox08 then declinervars.opt.pet.tell = DeclinerCheckBox08:GetChecked() end
	if DeclinerCheckBox09 then declinervars.opt.guild.tell = DeclinerCheckBox09:GetChecked() end
	if DeclinerCheckBox10 then declinervars.opt.group.tell = DeclinerCheckBox10:GetChecked() end
	if DeclinerCheckBox11 then declinervars.opt.chart.tell = DeclinerCheckBox11:GetChecked() end
	if DeclinerCheckBox12 then declinervars.opt.trade.tell = DeclinerCheckBox12:GetChecked() end
	if DeclinerCheckBox13 then declinervars.opt.duel.guild = DeclinerCheckBox13:GetChecked() end
	if DeclinerCheckBox14 then declinervars.opt.pet.guild = DeclinerCheckBox14:GetChecked() end
	if DeclinerCheckBox15 then DeclinerCheckBox15:SetChecked(false) end
	if DeclinerCheckBox16 then declinervars.opt.group.guild = DeclinerCheckBox16:GetChecked() end
	if DeclinerCheckBox17 then declinervars.opt.chart.guild = DeclinerCheckBox17:GetChecked() end
	if DeclinerCheckBox18 then declinervars.opt.trade.guild = DeclinerCheckBox18:GetChecked() end
	if DeclinerCheckBox19 then declinervars.opt.duel.friend = DeclinerCheckBox19:GetChecked() end
	if DeclinerCheckBox20 then declinervars.opt.pet.friend = DeclinerCheckBox20:GetChecked() end
	if DeclinerCheckBox21 then declinervars.opt.guild.friend = DeclinerCheckBox21:GetChecked() end
	if DeclinerCheckBox22 then declinervars.opt.group.friend = DeclinerCheckBox22:GetChecked() end
	if DeclinerCheckBox23 then declinervars.opt.chart.friend = DeclinerCheckBox23:GetChecked() end
	if DeclinerCheckBox24 then declinervars.opt.trade.friend = DeclinerCheckBox24:GetChecked() end
	if DeclinerCheckBox25 then declinervars.opt.duel.bnet = DeclinerCheckBox25:GetChecked() end
	if DeclinerCheckBox26 then declinervars.opt.pet.bnet = DeclinerCheckBox26:GetChecked() end
	if DeclinerCheckBox27 then declinervars.opt.guild.bnet = DeclinerCheckBox27:GetChecked() end
	if DeclinerCheckBox28 then declinervars.opt.group.bnet = DeclinerCheckBox28:GetChecked() end
	if DeclinerCheckBox29 then declinervars.opt.chart.bnet = DeclinerCheckBox29:GetChecked() end
	if DeclinerCheckBox30 then declinervars.opt.trade.bnet = DeclinerCheckBox30:GetChecked() end
	if DeclinerCheckBox31 then declinervars.opt.duel.message = DeclinerCheckBox31:GetChecked() end
	if DeclinerCheckBox32 then declinervars.opt.pet.message = DeclinerCheckBox32:GetChecked() end
	if DeclinerCheckBox33 then declinervars.opt.guild.message = DeclinerCheckBox33:GetChecked() end
	if DeclinerCheckBox34 then declinervars.opt.group.message = DeclinerCheckBox34:GetChecked() end
	if DeclinerCheckBox35 then declinervars.opt.chart.message = DeclinerCheckBox35:GetChecked() end
	if DeclinerCheckBox36 then declinervars.opt.trade.message = DeclinerCheckBox36:GetChecked() end
	if DeclinerCheckBox37 then declinervars.opt.dcl.messages = DeclinerCheckBox37:GetChecked() end
	if DeclinerCheckBox38 then declinervars.opt.dcl.disable = DeclinerCheckBox38:GetChecked() end
	Decliner:MainEventReg()
end

function Decliner:MainEventReg()
	Decliner:DisableGT()
	if declinervars.opt.dcl.disable then
		Decliner:UnregisterAllEvents()
		StaticPopupDialogs['DUEL_REQUESTED'] = _StaticPopupDialogs['DUEL_REQUESTED']
		StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED'] = _StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
		StaticPopupDialogs['PARTY_INVITE'] = _StaticPopupDialogs['PARTY_INVITE']
		StaticPopupDialogs['PARTY_INVITE_XREALM'] = _StaticPopupDialogs['PARTY_INVITE_XREALM']
		Decliner:SetPetitionFrame('default')
		Decliner:SetTradeFrame('default')
		for i = 1, STATICPOPUP_NUMDIALOGS do
			frame = _G["StaticPopup"..i]
			Decliner:SetStaticPopup(frame, 'default')
		end
	else
		if not Decliner:IsEventRegistered('CHAT_MSG_SYSTEM') then Decliner:RegisterEvent('CHAT_MSG_SYSTEM') end
		if not Decliner:IsEventRegistered('CHAT_MSG_WHISPER_INFORM') then Decliner:RegisterEvent('CHAT_MSG_WHISPER_INFORM') end
		if not Decliner:IsEventRegistered('CVAR_UPDATE') then Decliner:RegisterEvent('CVAR_UPDATE') end
		if not Decliner:IsEventRegistered('DISABLE_DECLINE_GUILD_INVITE') then Decliner:RegisterEvent('DISABLE_DECLINE_GUILD_INVITE') end
		if not Decliner:IsEventRegistered('ENABLE_DECLINE_GUILD_INVITE') then Decliner:RegisterEvent('ENABLE_DECLINE_GUILD_INVITE') end
		if declinervars.opt.duel.enabled then
			Decliner:RegisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED'] = DeclinerDialog['DUEL_REQUESTED']
		else
			Decliner:UnregisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED'] = _StaticPopupDialogs['DUEL_REQUESTED']
		end
		if declinervars.opt.pet.enabled then
			Decliner:RegisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED'] = DeclinerDialog['PET_BATTLE_PVP_DUEL_REQUESTED']
		else
			Decliner:UnregisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED'] = _StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
		end
		if declinervars.opt.guild.enabled then
			Decliner:RegisterEvent('GUILD_INVITE_REQUEST')
		else
			Decliner:UnregisterEvent('GUILD_INVITE_REQUEST')
		end
		if declinervars.opt.group.enabled then
			Decliner:RegisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE'] = DeclinerDialog['PARTY_INVITE']
			StaticPopupDialogs['PARTY_INVITE_XREALM'] = DeclinerDialog['PARTY_INVITE_XREALM']
		else
			Decliner:UnregisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE'] = _StaticPopupDialogs['PARTY_INVITE']
			StaticPopupDialogs['PARTY_INVITE_XREALM'] = _StaticPopupDialogs['PARTY_INVITE_XREALM']
		end
		if declinervars.opt.chart.enabled then
			Decliner:RegisterEvent('PETITION_SHOW')
			Decliner:SetPetitionFrame('decline')
		else
			Decliner:UnregisterEvent('PETITION_SHOW')
			Decliner:SetPetitionFrame('default')
		end
		if declinervars.opt.trade.enabled then
			Decliner:RegisterEvent('TRADE_SHOW')
			Decliner:RegisterEvent('TRADE_CLOSED')
			Decliner:SetTradeFrame('decline')
		else
			Decliner:UnregisterEvent('TRADE_SHOW')
			Decliner:UnregisterEvent('TRADE_CLOSED')
			Decliner:SetTradeFrame('default')
		end
		if declinervars.opt.duel.enabled or declinervars.opt.pet.enabled or declinervars.opt.group.enabled then
			for i=1, STATICPOPUP_NUMDIALOGS do
				frame = _G["StaticPopup"..i]
				Decliner:SetStaticPopup(frame, 'decline')
			end
		else
			for i = 1, STATICPOPUP_NUMDIALOGS do
				frame = _G["StaticPopup"..i]
				Decliner:SetStaticPopup(frame, 'default')
			end
		end
		if declinervars.opt.duel.enabled or declinervars.opt.pet.enabled or declinervars.opt.trade.enabled then Decliner:RegisterEvent('UI_INFO_MESSAGE') else Decliner:UnregisterEvent('UI_INFO_MESSAGE') end
	end
end

function Decliner:DisableGT()
	if declinervars.opt.guild.enabled and not declinervars.opt.dcl.disable then
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText("|cff666666"..BLOCK_GUILD_INVITES.." (Decliner)")
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Disable()
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES)
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Enable()
	end
	if declinervars.opt.trade.enabled and not declinervars.opt.dcl.disable then
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText("|cff666666"..BLOCK_TRADES.." (Decliner)")
		_G['InterfaceOptionsControlsPanelBlockTrades']:Disable()
		_G['InterfaceOptionsControlsPanelBlockTrades']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText(BLOCK_TRADES)
		_G['InterfaceOptionsControlsPanelBlockTrades']:Enable()
	end
end

function Decliner:SetPetitionFrame(action)
	PetitionFrame:SetScript('OnShow',nil)
	PetitionFrame:SetScript('OnHide',nil)
	if action == 'decline' then
		PetitionFrame:SetScript('OnHide',function()
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
		end)
	elseif action == 'default' and declinervars.opt.dcl.disable then
		PetitionFrame:SetScript('OnShow',function()
			PlaySoundKitID(875)
		end)
		PetitionFrame:SetScript('OnHide',function()
			PlaySoundKitID(876)
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
			ClosePetition()
		end)
	elseif action == 'default' then
		PetitionFrame:SetScript('OnShow',function()
			PlaySoundKitID(875)
		end)
		PetitionFrame:SetScript('OnHide',function()
			PlaySoundKitID(876)
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
			ClosePetition()
			if declinervars.opt.chart.enabled then Decliner:SetPetitionFrame('decline') end
		end)
	end
end

function Decliner:SetTradeFrame(action)
	TradeFrame:SetScript('OnShow',nil)
	TradeFrame:SetScript('OnHide',nil)
	if action == 'decline' then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
		end)
		TradeFrame:SetScript('OnHide',function()
			MoneyInputFrame_SetCopper(TradePlayerInputMoneyFrame, 0)
		end)
	elseif action == 'default' and declinervars.opt.dcl.disable then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
			PlaySoundKitID(839)
		end)
		TradeFrame:SetScript('OnHide',function()
			TradeFrame_OnHide()
			PlaySoundKitID(840)
		end)
	elseif action == 'default' then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
			PlaySoundKitID(839)
		end)
		TradeFrame:SetScript('OnHide',function()
			TradeFrame_OnHide()
			PlaySoundKitID(840)
			if declinervars.opt.trade.enabled then Decliner:SetTradeFrame('decline') end
		end)
	end
end

function Decliner:SetStaticPopup(frame, action)
	frame:SetScript('OnShow',nil)
	frame:SetScript('OnHide',nil)
	if action == 'decline' then
		frame:SetScript('OnShow',function()
			DeclinerDialog_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			DeclinerDialog_OnHide(frame)
		end)
	elseif action == 'default' and declinervars.opt.dcl.disable then
		frame:SetScript('OnShow',function()
			StaticPopup_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			StaticPopup_OnHide(frame)
		end)
	elseif action == 'default' then
		frame:SetScript('OnShow',function()
			StaticPopup_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			StaticPopup_OnHide(frame)
			if declinervars.opt.duel.enabled or declinervars.opt.pet.enabled or declinervars.opt.group.enabled then
				Decliner:SetStaticPopup(frame, 'decline')
			end
		end)
	end
end

function Decliner:ADDON_LOADED(addon)
	if addon == DECLINERNAME then
		_StaticPopupDialogs['DUEL_REQUESTED'] = StaticPopupDialogs['DUEL_REQUESTED']
		_StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED'] = StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
		_StaticPopupDialogs['PARTY_INVITE'] = StaticPopupDialogs['PARTY_INVITE']
		_StaticPopupDialogs['PARTY_INVITE_XREALM'] = StaticPopupDialogs['PARTY_INVITE_XREALM']
		if declinersavedvars.saved then
			for key1,value1 in pairs(declinervars.default) do
				if declinersavedvars[key1] == nil then
					declinersavedvars[key1] = declinervars.default[key1]
				end
				for key2,value2 in pairs(value1) do
					if declinersavedvars[key1][key2] == nil then
						declinersavedvars[key1][key2] = declinervars.default[key1][key2]
					elseif type(declinersavedvars[key1][key2]) ~= 'boolean' then
						declinersavedvars[key1][key2] = declinervars.default[key1][key2]
					end
				end
			end
			Decliner:CleanVars()
			declinervars.opt = declinersavedvars
			declinersavedvars.saved = true
		else
			Decliner:CleanVars()
			declinervars.opt = declinervars.default
			declinersavedvars = declinervars.default
			declinersavedvars.saved = true
		end
		Decliner:Options()
		Decliner:SetCheckBoxStates()
		oldSFX = GetCVar('Sound_EnableSFX')
		Decliner:GetCheckBoxStates()
		if not declinervars.opt.dcl.messages then DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..DECLINERNAME.." |cffffff00v"..GetAddOnMetadata(DECLINERNAME, 'Version').." "..string.lower(READY).."") end
		Decliner:UnregisterEvent('ADDON_LOADED')
	end
end

function Decliner:CHAT_MSG_SYSTEM(message)
	if string.match(message, tradeinisysmsg) then
		tradeinitiated = true
	end
end

function Decliner:CHAT_MSG_WHISPER_INFORM(_, name)
	lasttell = Decliner:fullName(name)
end

function Decliner:CVAR_UPDATE(cvar, value)
	oldSFX = GetCVar('Sound_EnableSFX')
	if cvar == 'BLOCK_TRADES' and value == '0' and not declinervars.opt.trade.enabled then
		declinervars.opt.trade.enabled = true
		Decliner:MainEventReg()
		Decliner:SetCheckBoxStates()
		Decliner:Print(DeclinerL['BLOCK_TRADES_OFF'])
	elseif cvar == 'BLOCK_TRADES' and value == '1' and declinervars.opt.trade.enabled then
		declinervars.opt.trade.enabled = false
		Decliner:MainEventReg()
		Decliner:SetCheckBoxStates()
		Decliner:Print(DeclinerL['BLOCK_TRADES_ON'])
	end
end

function Decliner:DISABLE_DECLINE_GUILD_INVITE()
	if not declinervars.opt.guild.enabled then
		declinervars.opt.guild.enabled = true
		Decliner:MainEventReg()
		Decliner:SetCheckBoxStates()
		Decliner:Print(DeclinerL['BLOCK_GUILDS_OFF'])
	end
end

function Decliner:ENABLE_DECLINE_GUILD_INVITE()
	if declinervars.opt.guild.enabled then
		declinervars.opt.guild.enabled = false
		Decliner:MainEventReg()
		Decliner:SetCheckBoxStates()
		Decliner:Print(DeclinerL['BLOCK_GUILDS_ON'])
	end
end

function Decliner:DUEL_REQUESTED(name)
	local _,frame = StaticPopup_Visible('DUEL_REQUESTED')
	HideUIPanel(frame)
	namerealm = Decliner:fullName(name)
	if ((lasttell ~= namerealm) or declinervars.opt.duel.tell) and
	(Decliner:isNotGuildie(namerealm) or declinervars.opt.duel.guild) and
	(Decliner:isNotFriend(namerealm) or declinervars.opt.duel.friend) and
	(Decliner:isNotBNFriend(namerealm) or declinervars.opt.duel.bnet) then
		CancelDuel()
		name = Decliner:localName(namerealm)
		if not declinervars.opt.duel.message then
			Decliner:Print(string.format(DeclinerL['DUEL_DECLINED'], "|Hplayer:"..name.."|h["..name.."]|h"))
		end
	else
		Decliner:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
	end
end

function Decliner:PET_BATTLE_PVP_DUEL_REQUESTED(name)
	local _,frame = StaticPopup_Visible('PET_BATTLE_PVP_DUEL_REQUESTED')
	HideUIPanel(frame)
	namerealm = Decliner:fullName(name)
	if ((lasttell ~= namerealm) or declinervars.opt.pet.tell) and
	(Decliner:isNotGuildie(namerealm) or declinervars.opt.pet.guild) and
	(Decliner:isNotFriend(namerealm) or declinervars.opt.pet.friend) and
	(Decliner:isNotBNFriend(namerealm) or declinervars.opt.pet.bnet) then
		C_PetBattles.CancelPVPDuel()
		name = Decliner:localName(namerealm)
		if not declinervars.opt.pet.message then
			Decliner:Print(string.format(DeclinerL['PET_DECLINED'], "|Hplayer:"..name.."|h["..name.."]|h"))
		end
	else
		Decliner:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
	end
end

function Decliner:GUILD_INVITE_REQUEST(name, guild)
	SetCVar('Sound_EnableSFX', '0')
	namerealm = Decliner:fullName(name)
	if ((lasttell ~= namerealm) or declinervars.opt.guild.tell) and
	(Decliner:isNotFriend(namerealm) or declinervars.opt.guild.friend) and
	(Decliner:isNotBNFriend(namerealm) or declinervars.opt.guild.bnet) then
		StaticPopupSpecial_Hide(GuildInviteFrame)
		DeclineGuild()
		name = Decliner:localName(namerealm)
		if not declinervars.opt.guild.message then
			Decliner:Print(string.format(DeclinerL['GUILD_DECLINED'], "|Hplayer:"..name.."|h["..name.."]|h", guild))
		end
		C_Timer.After(0.5, function() SetCVar('Sound_EnableSFX', oldSFX) end)
	else
		C_Timer.After(0.5, function()
			SetCVar('Sound_EnableSFX', oldSFX)
			PlaySoundKidID(888)
		end)
	end
end

function Decliner:PARTY_INVITE_REQUEST(name)
	local _,frame = StaticPopup_Visible('PARTY_INVITE')
	if not frame then local _,frame = StaticPopup_Visible('PARTY_INVITE_XREALM') end
	HideUIPanel(frame)
	namerealm = Decliner:fullName(name)
	if ((lasttell ~= namerealm) or declinervars.opt.group.tell) and
	(Decliner:isNotGuildie(namerealm) or declinervars.opt.group.guild) and
	(Decliner:isNotFriend(namerealm) or declinervars.opt.group.friend) and
	(Decliner:isNotBNFriend(namerealm) or declinervars.opt.group.bnet) then
		DeclineGroup()
		name = Decliner:localName(namerealm)
		if not declinervars.opt.group.message then
			Decliner:Print(string.format(DeclinerL['GROUP_DECLINED'], "|Hplayer:"..name.."|h["..name.."]|h"))
		end
	else
		Decliner:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
		StaticPopupDialogs['PARTY_INVITE'].OnHide = function(self)
			if (not self.inviteAccepted) then
				DeclineGroup()
				self:Hide()
			end
			StaticPopupDialogs['PARTY_INVITE'] = DeclinerDialog['PARTY_INVITE']
		end
		StaticPopupDialogs['PARTY_INVITE_XREALM'].OnHide = function(self)
			if (not self.inviteAccepted) then
				DeclineGroup()
				self:Hide()
			end
			StaticPopupDialogs['PARTY_INVITE_XREALM'] = DeclinerDialog['PARTY_INVITE_XREALM']
		end
	end
end

function Decliner:PETITION_SHOW()
	HideUIPanel(PetitionFrame)
	local ptype, _, _, _, name, isOriginator = GetPetitionInfo()
	namerealm = Decliner:fullName(name)
	if not isOriginator and
	((lasttell ~= namerealm) or declinervars.opt.chart.tell) and
	(Decliner:isNotGuildie(namerealm) or declinervars.opt.chart.guild) and
	(Decliner:isNotFriend(namerealm) or declinervars.opt.chart.friend) and
	(Decliner:isNotBNFriend(namerealm) or declinervars.opt.chart.bnet) then
		ClosePetition()
		name = Decliner:localName(namerealm)
		if not declinervars.opt.chart.message then
			if ptype == 'arena' then
				Decliner:Print(string.format(DeclinerL['CHART_DECLINED_ARENA'], "|Hplayer:"..name.."|h["..name.."]|h"))
			elseif ptype == 'guild' then
				Decliner:Print(string.format(DeclinerL['CHART_DECLINED_GUILD'], "|Hplayer:"..name.."|h["..name.."]|h"))
			else Decliner:Print(string.format(DeclinerL['CHART_DECLINED_NIL'], "|Hplayer:"..name.."|h["..name.."]|h"))
			end
		end
	else
		Decliner:SetPetitionFrame('default')
		ShowUIPanel(PetitionFrame)
	end
end

function Decliner:TRADE_SHOW()
	HideUIPanel(TradeFrame)
	local name, realm = UnitName('npc') -- credit to http://wowprogramming.com/forums/development/250 (and the hint next to 'npc' at http://wowprogramming.com/docs/api_types#unitID) since TRADE_SHOW doesn't pass a name
	if not realm then
		namerealm = Decliner:fullName(name)
	else
		namerealm = name..'-'..realm
	end
	if not tradeinitiated and
	((lasttell ~= namerealm) or declinervars.opt.trade.tell) and
	(Decliner:isNotGuildie(namerealm) or declinervars.opt.trade.guild) and
	(Decliner:isNotFriend(namerealm) or declinervars.opt.trade.friend) and
	(Decliner:isNotBNFriend(namerealm) or declinervars.opt.trade.bnet) then
		CloseTrade()
		name = Decliner:localName(namerealm)
		if not declinervars.opt.trade.message then
			Decliner:Print(string.format(DeclinerL['TRADE_DECLINED'], "|Hplayer:"..name.."|h["..name.."]|h"))
		end
	else
		Decliner:SetTradeFrame('default')
		ShowUIPanel(TradeFrame)
	end
end

function Decliner:TRADE_CLOSED()
	tradeinitiated = false
end

function Decliner:UI_INFO_MESSAGE(message)
	if (string.match(message, '.*'..Decliner:Patterns(ERR_DUEL_CANCELLED)..'.*') and declinervars.opt.duel.enabled) or
	(string.match(message, '.*'..Decliner:Patterns(ERR_PETBATTLE_DECLINED)..'.*') and declinervars.opt.pet.enabled) or
	(string.match(message, '.*'..Decliner:Patterns(ERR_TRADE_CANCELLED)..'.*') and declinervars.opt.trade.enabled) then
		UIErrorsFrame:Clear()
	end
end

Decliner:RegisterEvent('ADDON_LOADED')
Decliner:RegisterEvent('CHAT_MSG_SYSTEM')
Decliner:RegisterEvent('CHAT_MSG_WHISPER_INFORM')
Decliner:RegisterEvent('CVAR_UPDATE')
Decliner:RegisterEvent('DISABLE_DECLINE_GUILD_INVITE')
Decliner:RegisterEvent('ENABLE_DECLINE_GUILD_INVITE')
Decliner:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)

DeclinerDialog['DUEL_REQUESTED'] = {
	text = DUEL_REQUESTED,
	button1 = ACCEPT,
	button2 = DECLINE,
	OnAccept = function(self)
		AcceptDuel()
	end,
	OnCancel = function(self)
		CancelDuel()
	end,
	timeout = STATICPOPUP_TIMEOUT,
	hideOnEscape = 1
}

DeclinerDialog['PET_BATTLE_PVP_DUEL_REQUESTED'] = {
	text = PET_BATTLE_PVP_DUEL_REQUESTED,
	button1 = ACCEPT,
	button2 = DECLINE,
	OnAccept = function(self)
		C_PetBattles.AcceptPVPDuel()
	end,
	OnCancel = function(self)
		C_PetBattles.CancelPVPDuel()
	end,
	timeout = STATICPOPUP_TIMEOUT,
	hideOnEscape = 1
}

DeclinerDialog['PARTY_INVITE'] = {
	text = INVITATION,
	button1 = ACCEPT,
	button2 = DECLINE,
	OnShow = function(self)
		self.inviteAccepted = nil
	end,
	OnAccept = function(self)
		AcceptGroup()
		self.inviteAccepted = 1
	end,
	OnCancel = function(self)
		DeclineGroup()
	end,
	OnHide = function(self)
		if (not self.inviteAccepted) then
			self:Hide()
		end
	end,
	timeout = STATICPOPUP_TIMEOUT,
	whileDead = 1,
	hideOnEscape = 1
}

DeclinerDialog['PARTY_INVITE_XREALM'] = {
	text = INVITATION_XREALM,
	button1 = ACCEPT,
	button2 = DECLINE,
	OnShow = function(self)
		self.inviteAccepted = nil
	end,
	OnAccept = function(self)
		AcceptGroup()
		self.inviteAccepted = 1
	end,
	OnCancel = function(self)
		DeclineGroup()
	end,
	OnHide = function(self)
		if (not self.inviteAccepted) then
			self:Hide()
		end
	end,
	timeout = STATICPOPUP_TIMEOUT,
	whileDead = 1,
	hideOnEscape = 1
}

DeclinerDialog_OnShow = function(frame)
	local dialog = frame.which
	if dialog and
	((dialog == 'DUEL_REQUESTED' and declinervars.opt.duel.enabled) or
	(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and declinervars.opt.pet.enabled) or
	((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and declinervars.opt.group.enabled)) then
		local OnShow = dialog.OnShow
		if (OnShow) then
			OnShow(frame, frame.data)
		end
		if (dialog.enterClicksFirstButton) then
			frame:SetScript('OnKeyDown', StaticPopup_OnKeyDown)
		end
	else
		StaticPopup_OnShow(frame)
	end
end

DeclinerDialog_OnHide = function(frame)
	local dialog = frame.which
	if dialog and
	((dialog == 'DUEL_REQUESTED' and declinervars.opt.duel.enabled) or
	(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and declinervars.opt.pet.enabled) or
	((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and declinervars.opt.group.enabled)) then
		StaticPopup_CollapseTable()
		local OnHide = dialog.OnHide
		if (OnHide) then
			OnHide(frame, frame.data)
		end
		if (dialog.enterClicksFirstButton) then
			frame:SetScript('OnKeyDown', nil)
		end
	else
		StaticPopup_OnHide(frame)
	end
end

-- below code from http://www.curse.com/addons/wow/blizzbugssuck
-- Fix InterfaceOptionsFrame_OpenToCategory not actually opening the category (and not even scrolling to it)
-- Confirmed still broken in 6.0.3.19243
-- Decliner note: still broken in 6.2.0.20253

function get_panel_name(panel)
	local tp = type(panel)
	local cat = INTERFACEOPTIONS_ADDONCATEGORIES
	if tp == 'string' then
		for i = 1, #cat do
			local p = cat[i]
			if p.name == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel
				end
			end
		end
	elseif tp == 'table' then
		for i = 1, #cat do
			local p = cat[i]
			if p == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel.name
				end
			end
		end
	end
end

function InterfaceOptionsFrame_OpenToCategory_Fix(panel)
	if doNotRun or InCombatLockdown() then return end
	local panelName = get_panel_name(panel)
	if not panelName then return end -- if its not part of our list return early
	local noncollapsedHeaders = {}
	local shownpanels = 0
	local mypanel
	local t = {}
	local cat = INTERFACEOPTIONS_ADDONCATEGORIES
	for i = 1, #cat do
		local panel = cat[i]
		if not panel.parent or noncollapsedHeaders[panel.parent] then
			if panel.name == panelName then
				panel.collapsed = true
				t.element = panel
				InterfaceOptionsListButton_ToggleSubCategories(t)
				noncollapsedHeaders[panel.name] = true
				mypanel = shownpanels + 1
			end
			if not panel.collapsed then
				noncollapsedHeaders[panel.name] = true
			end
			shownpanels = shownpanels + 1
		end
	end
	local Smin, Smax = InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
	if shownpanels > 15 and Smin < Smax then
		local val = (Smax/(shownpanels-15))*(mypanel-2)
		InterfaceOptionsFrameAddOnsListScrollBar:SetValue(val)
	end
	doNotRun = true
	InterfaceOptionsFrame_OpenToCategory(panel)
	doNotRun = false
end

hooksecurefunc('InterfaceOptionsFrame_OpenToCategory', InterfaceOptionsFrame_OpenToCategory_Fix)